// Garden Gnome Software - Skin
// Pano2VR 5.1 beta2/15663
// Filename: map.ggsk
// Generated Tue Jan 17 15:40:31 2017

function pano2vrSkin(player,base) {
	var ggSkinVars = [];
	var me=this;
	var flag=false;
	this.player=player;
	this.player.skinObj=this;
	this.divSkin=player.divSkin;
	this.ggUserdata=me.player.userdata;
	this.lastSize={ w: -1,h: -1 };
	var basePath="";
	// auto detect base path
	if (base=='?') {
		var scripts = document.getElementsByTagName('script');
		for(var i=0;i<scripts.length;i++) {
			var src=scripts[i].src;
			if (src.indexOf('skin.js')>=0) {
				var p=src.lastIndexOf('/');
				if (p>=0) {
					basePath=src.substr(0,p+1);
				}
			}
		}
	} else
	if (base) {
		basePath=base;
	}
	this.elementMouseDown=[];
	this.elementMouseOver=[];
	var cssPrefix='';
	var domTransition='transition';
	var domTransform='transform';
	var prefixes='Webkit,Moz,O,ms,Ms'.split(',');
	var i;
	if (typeof document.body.style['transform'] == 'undefined') {
		for(var i=0;i<prefixes.length;i++) {
			if (typeof document.body.style[prefixes[i] + 'Transform'] !== 'undefined') {
				cssPrefix='-' + prefixes[i].toLowerCase() + '-';
				domTransition=prefixes[i] + 'Transition';
				domTransform=prefixes[i] + 'Transform';
			}
		}
	}
	
	this.player.setMargins(0,0,0,0);
	
	this.updateSize=function(startElement) {
		var stack=[];
		stack.push(startElement);
		while(stack.length>0) {
			var e=stack.pop();
			if (e.ggUpdatePosition) {
				e.ggUpdatePosition();
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	
	parameterToTransform=function(p) {
		var hs='translate(' + p.rx + 'px,' + p.ry + 'px) rotate(' + p.a + 'deg) scale(' + p.sx + ',' + p.sy + ')';
		return hs;
	}
	
	this.findElements=function(id,regex) {
		var r=[];
		var stack=[];
		var pat=new RegExp(id,'');
		stack.push(me.divSkin);
		while(stack.length>0) {
			var e=stack.pop();
			if (regex) {
				if (pat.test(e.ggId)) r.push(e);
			} else {
				if (e.ggId==id) r.push(e);
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
		return r;
	}
	
	this.addSkin=function() {
		var hs='';
		this.ggCurrentTime=new Date().getTime();
		this._map_1=document.createElement('div');
		this._map_1.innerHTML='Map goes here...';
		this._map_1.ggFilter = '';
		this._map_1.ggFilteredIds = [];
		this._map_1.ggId="Map 1";
		this._map_1.ggLeft=-214;
		this._map_1.ggTop=-163;
		this._map_1.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._map_1.ggVisible=true;
		this._map_1.className='ggskin ggskin_map ';
		this._map_1.ggType='map';
		hs ='';
		hs+='background : #fff;';
		hs+='border : 1px solid #000;';
		hs+='height : 300px;';
		hs+='left : -214px;';
		hs+='position : absolute;';
		hs+='top : -163px;';
		hs+='visibility : inherit;';
		hs+='width : 410px;';
		hs+='pointer-events:auto;';
		this._map_1.setAttribute('style',hs);
		this._map_1.style[domTransform + 'Origin']='50% 50%';
		me._map_1.ggIsActive=function() {
			return false;
		}
		me._map_1.ggElementNodeId=function() {
			return me.player.getCurrentNode();
		}
		this._map_1.ggUpdateConditionTimer=function () {
			me._map_1.ggRadar.update();
		}
		this._map_1.ggUpdateConditionNodeChange=function () {
			me._map_1.ggCallChildFunctions('ggNodeChangeMain');
		}
		this._map_1.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var w=this.parentNode.offsetWidth;
					this.style.left=(this.ggLeft - 0 + w/2) + 'px';
				var h=this.parentNode.offsetHeight;
					this.style.top=(this.ggTop - 0 + h/2) + 'px';
			}
		}
		this._map_1.ggNodeChange=function () {
			if (this.ggLastActivMarker) {
				if (this.ggLastActivMarker._div.ggDeactivate) this.ggLastActivMarker._div.ggDeactivate();
			}
			var id=me.player.getCurrentNode();
			var marker=this.ggMarkerArray[id];
			if (marker) {
				if (marker._div.ggActivate) marker._div.ggActivate();
			}
			this.ggLastActivMarker=marker;
			me._map_1.ggUpdateConditionNodeChange();
		}
		this.divSkin.appendChild(this._map_1);
		this._map_1.ggRadar={ lastFov : -1, lastPan : -1, lastZoom : -1,activeNodeLatLng : null, poly : null }
		this._map_1.ggRadar.update=function() {
			if ((typeof google !== 'object') || (typeof google.maps !== 'object')) return;
			var radar=me._map_1.ggRadar;
			var map=me._map_1.ggMap;
			if (!map) return;
			var d2r = Math.PI/180 ;
			var r2d = 180/Math.PI ;
			var fov = me.player.getFov();
			var pan = me.player.getPanNorth();
			var zoom = map.getZoom();
			var gps=me.player.getNodeLatLng();
			var filterpassed = true;
			var currentId = me.player.getCurrentNode();
			if (me._map_1.ggFilteredIds.length > 0 && me._map_1.ggFilteredIds.indexOf(currentId) == -1) filterpassed = false;
			if ((gps.length>=2) && ((gps[0]!=0) || (gps[1]!=0)) && filterpassed) {
				if (zoom<6) zoom = 6; // avoid large radar beams on world map
				if ((fov==radar.lastFov) && (pan==radar.lastPan) && (zoom==radar.lastZoom) && (gps[0]==radar.activeNodeLatLng.lat()) && (gps[1]==radar.activeNodeLatLng.lng())) return; 
				radar.lastPan=pan;radar.lastFov=fov;radar.lastZoom=zoom;
				radar.activeNodeLatLng = new google.maps.LatLng(gps[0], gps[1]);
				var rLat = 4.0*r2d / Math.pow(2,zoom);     // beam size
				var rLng = rLat/Math.cos(radar.activeNodeLatLng.lat() * d2r);
				var radar_path = [];
				radar_path.push(radar.activeNodeLatLng);
				var segments=5;
				for (i=-segments; i<=segments; i++) {
					var angle = (fov / (2*segments)) * i;
					var x = -rLng * Math.sin((pan+angle)*d2r) + radar.activeNodeLatLng.lng();
					var y =  rLat * Math.cos((pan+angle)*d2r) + radar.activeNodeLatLng.lat();
					radar_path.push(new google.maps.LatLng(y, x));
				}
				if (radar.poly) {
					radar.poly.setMap(null);
					radar.poly = null;
				}
				radar.poly = new google.maps.Polygon({
					paths: radar_path,
					strokeColor: '#ff0000',
					strokeOpacity: 0.8,
					strokeWeight: 1,
					fillColor: '#ff0000',
					fillOpacity: 0.35
				});
				radar.poly.setMap(map);
			} else {
				if (radar) {
					activeNodeLatLng = new google.maps.LatLng(0,0);
					if (radar.poly) {
						radar.poly.setMap(null);
						radar.poly = null;
					}
				}
			}
		}
		this._map_1.ggMarkerArray=[];
		this._map_1.ggGoogleMarkerArray=[];
		this._map_1.ggInitMap=function() {
		me._map_1.ggMapNotLoaded = false;
			if ((typeof google !== 'object') || (typeof google.maps !== 'object')) return;
			var gps=me.player.getNodeLatLng();
			if ((gps.length>=2) && ((gps[0]!=0) || (gps[1]!=0))) {
				activeNodeLatLng = new google.maps.LatLng(gps[0], gps[1]);
			} else {
				activeNodeLatLng = new google.maps.LatLng(0,0);
			}
			var mapOptions = {
				zoom: 14,
				center: activeNodeLatLng,
				mapTypeId: google.maps.MapTypeId.HYBRID,
				streetViewControl: false
			};
			me._map_1.ggMap = new google.maps.Map(me._map_1, mapOptions);
			me._map_1.ggNodeChange();
			google.maps.event.addListener(me._map_1.ggMap, 'idle', function(){
				me.updateSize(me._map_1);
			});
		}
		this._map_1.ggClearMap=function() {
		me._map_1.ggMap = null;
		me._map_1.ggClearMapMarkers();
		me._map_1.ggMapNotLoaded = true;
		}
		this._map_1.ggClearMapMarkers=function() {
			var id,marker;
			var markers=me._map_1.ggMarkerArray;
			for (id in markers) {
				if (markers.hasOwnProperty(id)) {
					marker=markers[id];
					marker.onRemove();
				}
			}
			me._map_1.ggMarkerArray=[];
		}
		this._map_1.ggInitMapMarkers=function(updateMapBounds) {
			function SkinMarkerOverlay(pos, div, map) {
				this._pos = pos;
				this._div = div;
				this._map = map;
				this.setMap(map);
			}
			SkinMarkerOverlay.prototype = new google.maps.OverlayView();
			SkinMarkerOverlay.prototype.onAdd = function() {
				this.getPanes().overlayMouseTarget.appendChild(this._div);
			}
			SkinMarkerOverlay.prototype.draw = function() {
				var overlayProjection = this.getProjection();
				var point = this.getProjection().fromLatLngToDivPixel(this._pos);
				if (point) {
					this._div.style.left =(point.x - 8) + 'px';
					this._div.style.top =(point.y - 8) + 'px';
				}
			};
			SkinMarkerOverlay.prototype.onRemove = function() {
				this._div.parentNode.removeChild(this._div);
				this._div = null;
			};
			SkinMarkerOverlay.prototype.getPosition = function() {
				return this._pos;
			};
			me._map_1.ggClearMapMarkers();
			var ids=me.player.getNodeIds();
			me._map_1.ggFilteredIds = [];
			if (me._map_1.ggFilter != '') {
				var filter = me._map_1.ggFilter.split(',');
				for (i=0; i < ids.length; i++) {
					var nodeId = ids[i];
					var nodeData = me.player.getNodeUserdata(nodeId);
					for (j=0; j < filter.length; j++) {
						if (nodeData['tags'].indexOf(filter[j].trim()) != -1) me._map_1.ggFilteredIds.push(nodeId);
					}
				}
				if (me._map_1.ggFilteredIds.length > 0) ids = me._map_1.ggFilteredIds;
			}
			var marker;
			var markerLocation;
			var bounds=new google.maps.LatLngBounds();
			for(var i=0;i<ids.length;i++) {
				var id=ids[i];
				var gps=me.player.getNodeLatLng(id);
				if ((gps.length>=2) && ((gps[0]!=0) || (gps[1]!=0))) {
					markerLocation = new google.maps.LatLng(gps[0], gps[1]);
					var markerParent = new Object();
					markerParent.ggElementNodeId=function() { return id };
					var div=new SkinElement_map_pin_Class(me,markerParent);
					marker=new SkinMarkerOverlay(markerLocation,div,me._map_1.ggMap);

					me._map_1.ggMarkerArray[id]=marker;
					bounds.extend(markerLocation);
				}
			}
			if (ids.length > 1 && !bounds.isEmpty() && updateMapBounds) {
				me._map_1.ggMap.fitBounds(bounds);
			}
			this.ggLastActivMarker = null;
			if (this.ggUpdateConditionNodeChange) this.ggUpdateConditionNodeChange();
			this.ggRadar.lastFov = -1;
		}
		this._map_1.ggCallChildFunctions = function(functionname) {
			var id,marker;
			var markers=me._map_1.ggMarkerArray;
			for (id in markers) {
				if (markers.hasOwnProperty(id)) {
					marker=markers[id];
					if (typeof marker._div[functionname] == 'function') {
						marker._div[functionname]();
					}
				}
			}
		}
		this.divSkin.ggUpdateSize=function(w,h) {
			me.updateSize(me.divSkin);
		}
		this.divSkin.ggViewerInit=function() {
			me._map_1.ggInitMap();
			me._map_1.ggInitMapMarkers(true);
		}
		this.divSkin.ggLoaded=function() {
		}
		this.divSkin.ggReLoaded=function() {
		}
		this.divSkin.ggLoadedLevels=function() {
		}
		this.divSkin.ggReLoadedLevels=function() {
		}
		this.divSkin.ggEnterFullscreen=function() {
		}
		this.divSkin.ggExitFullscreen=function() {
		}
		this.skinTimerEvent();
	};
	this.hotspotProxyClick=function(id) {
	}
	this.hotspotProxyOver=function(id) {
	}
	this.hotspotProxyOut=function(id) {
	}
	this.changeActiveNode=function(id) {
		me.ggUserdata=me.player.userdata;
		me._map_1.ggNodeChange();
	}
	this.skinTimerEvent=function() {
		setTimeout(function() { me.skinTimerEvent(); }, 10);
		me.ggCurrentTime=new Date().getTime();
		me._map_1.ggUpdateConditionTimer();
	};
	function SkinElement_map_pin_Class(skinObj,ggParent) {
		var me=this;
		var flag=false;
		this.player=skinObj.player;
		this.skin=skinObj;
		this.ggParent=ggParent;
		var nodeId=ggParent.ggElementNodeId();
		this.ggNodeId=nodeId;
		this.ggUserdata=this.skin.player.getNodeUserdata(nodeId);
		this.elementMouseDown=[];
		this.elementMouseOver=[];
		
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		
		this._map_pin=document.createElement('div');
		this._map_pin.ggId="map_pin";
		this._map_pin.ggLeft=-294;
		this._map_pin.ggTop=-209;
		this._map_pin.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._map_pin.ggVisible=true;
		this._map_pin.className='ggskin ggskin_container ';
		this._map_pin.ggType='container';
		hs ='';
		hs+='height : 16px;';
		hs+='left : -294px;';
		hs+='position : absolute;';
		hs+='top : -209px;';
		hs+='visibility : inherit;';
		hs+='width : 16px;';
		hs+='pointer-events:none;';
		this._map_pin.setAttribute('style',hs);
		this._map_pin.style[domTransform + 'Origin']='50% 50%';
		me._map_pin.ggIsActive=function() {
			return me.player.getCurrentNode()==this.ggElementNodeId();
		}
		me._map_pin.ggElementNodeId=function() {
			return me.ggNodeId;
		}
		this._map_pin.onclick=function (e) {
			me.player.openNext("{"+me.ggNodeId+"}","");
		}
		this._map_pin.ggUpdatePosition=function (useTransition) {
		}
		this._map_red=document.createElement('div');
		this._map_red.ggId="map_red";
		this._map_red.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._map_red.ggVisible=false;
		this._map_red.className='ggskin ggskin_rectangle ';
		this._map_red.ggType='rectangle';
		hs ='';
		hs+=cssPrefix + 'border-radius : 999px;';
		hs+='border-radius : 999px;';
		hs+='background : #ff0000;';
		hs+='border : 1px solid #000000;';
		hs+='cursor : pointer;';
		hs+='height : 15px;';
		hs+='left : 0px;';
		hs+='position : absolute;';
		hs+='top : 0px;';
		hs+='visibility : hidden;';
		hs+='width : 15px;';
		hs+='pointer-events:auto;';
		this._map_red.setAttribute('style',hs);
		this._map_red.style[domTransform + 'Origin']='50% 50%';
		me._map_red.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._map_red.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		me._map_red.ggCurrentLogicStateVisible = -1;
		this._map_red.ggUpdateConditionNodeChange=function () {
			var newLogicStateVisible;
			if (
				(me.ggUserdata.tags.indexOf("red") != -1)
			)
			{
				newLogicStateVisible = 0;
			}
			else {
				newLogicStateVisible = -1;
			}
			if (me._map_red.ggCurrentLogicStateVisible != newLogicStateVisible) {
				me._map_red.ggCurrentLogicStateVisible = newLogicStateVisible;
				me._map_red.style[domTransition]='';
				if (me._map_red.ggCurrentLogicStateVisible == 0) {
					me._map_red.style.visibility=(Number(me._map_red.style.opacity)>0||!me._map_red.style.opacity)?'inherit':'hidden';
					me._map_red.ggVisible=true;
				}
				else {
					me._map_red.style.visibility="hidden";
					me._map_red.ggVisible=false;
				}
			}
		}
		this._map_red.ggUpdatePosition=function (useTransition) {
		}
		this._map_red.ggNodeChange=function () {
			me._map_red.ggUpdateConditionNodeChange();
		}
		this._map_pin.appendChild(this._map_red);
		this._map_green=document.createElement('div');
		this._map_green.ggId="map_green";
		this._map_green.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._map_green.ggVisible=false;
		this._map_green.className='ggskin ggskin_rectangle ';
		this._map_green.ggType='rectangle';
		hs ='';
		hs+=cssPrefix + 'border-radius : 999px;';
		hs+='border-radius : 999px;';
		hs+='background : #00ff00;';
		hs+='border : 1px solid #000000;';
		hs+='cursor : pointer;';
		hs+='height : 15px;';
		hs+='left : 0px;';
		hs+='position : absolute;';
		hs+='top : 0px;';
		hs+='visibility : hidden;';
		hs+='width : 15px;';
		hs+='pointer-events:auto;';
		this._map_green.setAttribute('style',hs);
		this._map_green.style[domTransform + 'Origin']='50% 50%';
		me._map_green.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._map_green.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		me._map_green.ggCurrentLogicStateVisible = -1;
		this._map_green.ggUpdateConditionNodeChange=function () {
			var newLogicStateVisible;
			if (
				(me.ggUserdata.tags.indexOf("green") != -1)
			)
			{
				newLogicStateVisible = 0;
			}
			else {
				newLogicStateVisible = -1;
			}
			if (me._map_green.ggCurrentLogicStateVisible != newLogicStateVisible) {
				me._map_green.ggCurrentLogicStateVisible = newLogicStateVisible;
				me._map_green.style[domTransition]='';
				if (me._map_green.ggCurrentLogicStateVisible == 0) {
					me._map_green.style.visibility=(Number(me._map_green.style.opacity)>0||!me._map_green.style.opacity)?'inherit':'hidden';
					me._map_green.ggVisible=true;
				}
				else {
					me._map_green.style.visibility="hidden";
					me._map_green.ggVisible=false;
				}
			}
		}
		this._map_green.ggUpdatePosition=function (useTransition) {
		}
		this._map_green.ggNodeChange=function () {
			me._map_green.ggUpdateConditionNodeChange();
		}
		this._map_pin.appendChild(this._map_green);
		this._map_blue=document.createElement('div');
		this._map_blue.ggId="map_blue";
		this._map_blue.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._map_blue.ggVisible=false;
		this._map_blue.className='ggskin ggskin_rectangle ';
		this._map_blue.ggType='rectangle';
		hs ='';
		hs+=cssPrefix + 'border-radius : 999px;';
		hs+='border-radius : 999px;';
		hs+='background : #0000ff;';
		hs+='border : 1px solid #000000;';
		hs+='cursor : pointer;';
		hs+='height : 15px;';
		hs+='left : 0px;';
		hs+='position : absolute;';
		hs+='top : 0px;';
		hs+='visibility : hidden;';
		hs+='width : 15px;';
		hs+='pointer-events:auto;';
		this._map_blue.setAttribute('style',hs);
		this._map_blue.style[domTransform + 'Origin']='50% 50%';
		me._map_blue.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._map_blue.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		me._map_blue.ggCurrentLogicStateVisible = -1;
		this._map_blue.ggUpdateConditionNodeChange=function () {
			var newLogicStateVisible;
			if (
				(me.ggUserdata.tags.indexOf("blue") != -1)
			)
			{
				newLogicStateVisible = 0;
			}
			else {
				newLogicStateVisible = -1;
			}
			if (me._map_blue.ggCurrentLogicStateVisible != newLogicStateVisible) {
				me._map_blue.ggCurrentLogicStateVisible = newLogicStateVisible;
				me._map_blue.style[domTransition]='';
				if (me._map_blue.ggCurrentLogicStateVisible == 0) {
					me._map_blue.style.visibility=(Number(me._map_blue.style.opacity)>0||!me._map_blue.style.opacity)?'inherit':'hidden';
					me._map_blue.ggVisible=true;
				}
				else {
					me._map_blue.style.visibility="hidden";
					me._map_blue.ggVisible=false;
				}
			}
		}
		this._map_blue.ggUpdatePosition=function (useTransition) {
		}
		this._map_blue.ggNodeChange=function () {
			me._map_blue.ggUpdateConditionNodeChange();
		}
		this._map_pin.appendChild(this._map_blue);
		this._map_pin.ggNodeChangeMain=function() {
			me._map_red.ggNodeChange();
			me._map_green.ggNodeChange();
			me._map_blue.ggNodeChange();
		}
		return this._map_pin;
	};
	this.addSkin();
};